
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>深入剖析ConcurrentHashMap 一 / iVAN</title>

    <meta name="description" content="深入剖析ConcurrentHashMap 一 ConcurrentHashMap是Java5中新增加的一个线程安全的Map集合,可以用来替代HashTable.对于ConcurrentHashMap是如何提高其效率的,可能大多人只是知道它使用了多个锁代替HashTable中的单个锁,也就是锁分离技术(Lock Stripping).实际上,ConcurrentHashMap对提高并发方面的优化,还有一些其它的技巧在里面(比如你是否知道在get操作的时候,它是否也使用了锁来保护?). 我会试图用通俗一点的方法讲解一下 ConcurrentHa">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">深入剖析ConcurrentHashMap 一</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>ConcurrentHashMap是Java5中新增加的一个线程安全的Map集合，可以用来替代HashTable。对于ConcurrentHashMap是如何提高其效率的，可能大多人只是知道它使用了多个锁代替HashTable中的单个锁，也就是锁分离技术（Lock Stripping）。实际上，ConcurrentHashMap对提高并发方面的优化，还有一些其它的技巧在里面（比如你是否知道在get操作的时候，它是否也使用了锁来保护？）。</p>
<p>我会试图用通俗一点的方法讲解一下 ConcurrentHashMap的实现方式，不过因为水平有限，在整理这篇文档的过程中，发现了更多自己未曾深入思考过的地方，使得我不得不从新调整了自己的讲解方式。我假设受众者大多是对Java存储模型(JMM)认识并不很深的（我本人也是）。如果我们不断的对ConcurrentHashMap中一些实现追问下去，最终还是要归到JMM层面甚至更底层的。这篇文章的关注点主要在同步方面，并不去分析HashMap中的一些数据结构方面的实现。</p>
<p>ConcurrentHashMap实现了ConcurrentMap接口，先看看 ConcurrentMap 接口的文档说明：</p>
<p>提供其他原子 putIfAbsent、remove、replace 方法的 Map。</p>
<p>内存一致性效果：当存在其他并发 collection 时，将对象放入 ConcurrentMap 之前的线程中的操作 happen-before 随后通过另一线程从 ConcurrentMap 中访问或移除该元素的操作。</p>
<p>我们不关心ConcurrentMap中新增的接口，重点理解一下内存一致性效果中的“happens-before”是怎么回事。因为要想从根本上讲明白，这个是无法避开的。这又不得不从Java存储模型来谈起了。</p>
<p>1. 理解JAVA存储模型(JMM)的Happens-Before规则。</p>
<p>在解释该规则之前，我们先看一段多线程访问数据的代码例子：</p>
<p>public class Test1 {<br />    private int a=1, b=2;</p>
<p>    public void foo(){  // 线程1<br />        a=3;<br />        b=4;<br />    }</p>
<p>    public int getA(){ // 线程2<br />        return a;<br />    }   <br />    public int getB(){ // 线程2<br />        return b;<br />    }<br />}<br />上面的代码，当线程1执行foo方法的时候，线程2访问getA和getB会得到什么样的结果？<br />答案：</p>
<p>A：a=1, b=2  // 都未改变<br />B：a=3, b=4  // 都改变了<br />C：a=3, b=2  //  a改变了，b未改变<br />D：a=1, b=4  //  b改变了，a未改变<br />上面的A,B,C都好理解，但是D可能会出乎一些人的预料。<br />一些不了解JMM的同学可能会问怎么可能 b=4语句会先于 a=3 执行？</p>
<p>这是一个多线程之间内存可见性（Visibility）顺序不一致的问题。有两种可能会造成上面的D选项。</p>
<p>1) Java编译器的重排序(Reording)操作有可能导致执行顺序和代码顺序不一致。<br />关于Reording：</p>
<p>Java语言规范规定了JVM要维护内部线程类似顺序化语义(within-thread as-is-serial semantics)：只要程序的最终结果等同于它在严格的顺序化环境中执行的结果，那么上述所有的行为都是允许的。</p>
<p>上面的话是《Java并发编程实践》一书中引自Java语言规范的，感觉翻译的不太好。简单的说：假设代码有两条语句，代码顺序是语句1先于语句2执行；那么只要语句2不依赖于语句1的结果，打乱它们的顺序对最终的结果没有影响的话，那么真正交给CPU去执行时，他们的顺序可以是没有限制的。可以允许语句2先于语句1被CPU执行，和代码中的顺序不一致。</p>
<p>重排序（Reordering）是JVM针对现代CPU的一种优化，Reordering后的指令会在性能上有很大提升。(不知道这种优化对于多核CPU是否更加明显，也或许和单核多核没有关系。)</p>
<p>因为我们例子中的两条赋值语句，并没有依赖关系，无论谁先谁后结果都是一样的，所以就可能有Reordering的情况，这种情况下，对于其他线程来说就可能造成了可见性顺序不一致的问题。</p>
<p>2) 从线程工作内存写回主存时顺序无法保证。<br />下图描述了JVM中主存和线程工作内存之间的交互：</p>
<p>JLS中对线程和主存互操作定义了6个行为，分别为load，save，read，write，assign和use，这些操作行为具有原子性，且相互依赖，有明确的调用先后顺序。这个细节也比较繁琐，我们暂不深入追究。先简单认为线程在修改一个变量时，先拷贝入线程工作内存中，在线程工作内存修改后再写回主存(Main Memery)中。</p>
<p>假设例子中Reording后顺序仍与代码中的顺序一致，那么接下来呢？<br />有意思的事情就发生在线程把Working Copy Memery中的变量写回Main Memery的时刻。<br />线程1把变量写回Main Memery的过程对线程2的可见性顺序也是无法保证的。<br />上面的列子，a=3; b=4; 这两个语句在 Working Copy Memery中执行后，写回主存的过程对于线程2来说同样可能出现先b=4；后a=3；这样的相反顺序。</p>
<p>正因为上面的那些问题，JMM中一个重要问题就是：如何让多线程之间，对象的状态对于各线程的“可视性”是顺序一致的。<br />它的解决方式就是 Happens-before 规则：<br />JMM为所有程序内部动作定义了一个偏序关系，叫做happens-before。要想保证执行动作B的线程看到动作A的结果（无论A和B是否发生在同一个线程中），A和B之间就必须满足happens-before关系。</p>
<p>我们现在来看一下“Happens-before”规则都有哪些（摘自《Java并发编程实践》）：</p>
<p>① 程序次序法则：线程中的每个动作A都happens-before于该线程中的每一个动作B，其中，在程序中，所有的动作B都能出现在A之后。<br />② 监视器锁法则：对一个监视器锁的解锁 happens-before于每一个后续对同一监视器锁的加锁。<br />③ volatile变量法则：对volatile域的写入操作happens-before于每一个后续对同一个域的读写操作。<br />④ 线程启动法则：在一个线程里，对Thread.start的调用会happens-before于每个启动线程的动作。<br />⑤ 线程终结法则：线程中的任何动作都happens-before于其他线程检测到这个线程已经终结、或者从Thread.join调用中成功返回，或Thread.isAlive返回false。<br />⑥ 中断法则：一个线程调用另一个线程的interrupt happens-before于被中断的线程发现中断。<br />⑦ 终结法则：一个对象的构造函数的结束happens-before于这个对象finalizer的开始。<br />⑧ 传递性：如果A happens-before于B，且B happens-before于C，则A happens-before于C<br />（更多关于happens-before描述见附注2）</p>
<p>我们重点关注的是②，③，这两条也是我们通常编程中常用的。<br />后续分析ConcurrenHashMap时也会看到使用到锁(ReentrantLock)，Volatile，final等手段来保证happens-before规则的。</p>
<p>使用锁方式实现“Happens-before”是最简单，容易理解的。</p>
<p>早期Java中的锁只有最基本的synchronized，它是一种互斥的实现方式。在Java5之后，增加了一些其它锁，比如ReentrantLock，它基本作用和synchronized相似，但提供了更多的操作方式，比如在获取锁时不必像synchronized那样只是傻等，可以设置定时，轮询，或者中断，这些方法使得它在获取多个锁的情况可以避免死锁操作。</p>
<p>而我们需要了解的是ReentrantLock的性能相对synchronized来说有很大的提高。（不过据说Java6后对synchronized进行了优化，两者已经接近了。）在ConcurrentHashMap中，每个hash区间使用的锁正是ReentrantLock。</p>
<p>Volatile可以看做一种轻量级的锁，但又和锁有些不同。<br />a) 它对于多线程，不是一种互斥（mutex）关系。<br />b) 用volatile修饰的变量，不能保证该变量状态的改变对于其他线程来说是一种“原子化操作”。</p>
<p>在Java5之前，JMM对Volatile的定义是：保证读写volatile都直接发生在main memory中，线程的working memory不进行缓存。<br />它只承诺了读和写过程的可见性，并没有对Reording做限制，所以旧的Volatile并不太可靠。<br />在Java5之后，JMM对volatile的语义进行了增强。就是我们看到的③ volatile变量法则</p>
<p>那对于“原子化操作”怎么理解呢？看下面例子：</p>
<p>private static volatile int nextSerialNum = 0;</p>
<p>public static int generateSerialNumber(){<br />    return nextSerialNum++;<br />}<br />上面代码中对nextSerialNum使用了volatile来修饰，根据前面“Happens-Before”法则的第三条Volatile变量法则，看似不同线程都会得到一个新的serialNumber</p>
<p>问题出在了 nextSerialNum++ 这条语句上，它不是一个原子化的，实际上是read-modify-write三项操作，这就有可能使得在线程1在write之前，线程2也访问到了nextSerialNum，造成了线程1和线程2得到一样的serialNumber。<br />所以，在使用Volatile时，需要注意<br />a) 需不需要互斥；<br />b）对象状态的改变是不是原子化的。</p>
<p>最后也说一下final 关键字。<br />不变模式（immutable）是多线程安全里最简单的一种保障方式。因为你拿他没有办法，想改变它也没有机会。<br />不变模式主要通过final关键字来限定的。<br />在JMM中final关键字还有特殊的语义。Final域使得确保初始化安全性（initialization safety）成为可能，初始化安全性让不可变形对象不需要同步就能自由地被访问和共享。</p>
<p>2）经过前面的了解，下面我们用Happens-Before规则理解一个经典问题：双重检测锁(DCL)为什么在java中不适用？</p>
<p>public class LazySingleton {<br />    private int                  someField;<br />    private static LazySingleton instance;</p>
<p>    private LazySingleton(){<br />        this.someField = new Random().nextInt(200) + 1; // (1)<br />    }</p>
<p>    public static LazySingleton getInstance() {<br />        if (instance == null) {// (2)<br />            synchronized (LazySingleton.class) { // (3)<br />              if (instance == null) { // (4)<br />                instance = new LazySingleton(); // (5)<br />              }<br />            }<br />        }<br />        return instance; // (6)<br />    }</p>
<p>    public int getSomeField() {<br />        return this.someField;  // (7)<br />    }<br />}<br />这里例子的详细解释可以看这里：http://www.javaeye.com/topic/260515?page=1<br />他解释的太详细了，是基于数学证明来分析的，看似更严谨一些，他的证明是因为那几条语句之间不存在Happens-before约束，所以它们不能保证可见性顺序。理解起来有些抽象，对于经验不多的程序员来说缺乏更有效的说服力。</p>
<p>我想简单的用对象创建期间的实际场景来分析一下：（注意，这种场景是我个人的理解，所看的资料也是非官方的，不完全保证正确。如果发现不对请指出。见附注1）</p>
<p>假设线程1执行完(5)时，线程2正好执行到了(2)；<br />看看 new LazySingleton(); 这个语句的执行过程： 它不是一个原子操作，实际是由多个步骤，我们从我们关注的角度简化一下，简单的认为它主要有2步操作好了：<br />a） 在内存中分配空间，并将引用指向该内存空间。<br />b） 执行对象的初始化的逻辑(和操作)，完成对象的构建。</p>
<p>此时因为线程1和线程2没有用同步，他们之间不存在“Happens-Before”规则的约束，所以在线程1创建LazySingleton对象的 a),b)这两个步骤对于线程2来说会有可能出现a)可见，b)不可见<br />造成了线程2获取到了一个未创建完整的lazySingleton对象引用，为后边埋下隐患。</p>
<p>之所以这里举到 DCL这个例子，是因为我们后边分析ConcurrentHashMap时，也会遇到相似的情况。<br />对于对象的创建，出于乐观考虑，两个线程之间没有用“Happens-Before规则来约束”另一个线程可能会得到一个未创建完整的对象，这种情况必须要检测，后续分析ConcurrentHashMap时再讨论。</p>
<p>附注1：<br />我所定义的场景，是基于对以下资料了解的，比较低层，没有细看。<br />原文：http://www.cs.umd.edu/~pugh/java/memoryModel/DoubleCheckedLocking.html<br />其中分析一个对象创建过程的部分摘抄如下：</p>
<p>singletons[i].reference = new Singleton();<br />to the following (note that the Symantec JIT using a handle-based object allocation system).</p>
<p>0206106A   mov         eax,0F97E78h<br />0206106F   call        01F6B210                  ; allocate space for<br />                                             ; Singleton, return result in eax<br />02061074   mov         dword ptr [ebp],eax       ; EBP is &amp;singletons[i].reference<br />                                            ; store the unconstructed object here.<br />02061077   mov         ecx,dword ptr [eax]       ; dereference the handle to<br />                                             ; get the raw pointer<br />02061079   mov         dword ptr [ecx],100h      ; Next 4 lines are<br />0206107F   mov         dword ptr [ecx+4],200h    ; Singleton's inlined constructor<br />02061086   mov         dword ptr [ecx+8],400h<br />0206108D   mov         dword ptr [ecx+0Ch],0F84030h<br />As you can see, the assignment to singletons[i].reference is performed before the constructor for Singleton is called. This is completely legal under the existing Java memory model, and also legal in C and C++ (since neither of them have a memory model).</p>
<p>另外，从JVM创建一个对象的过程来看，分为：“装载”，“连接”，“初始化”三个步骤。<br />在连接步骤中包含“验证”，“准备”，“解析”这几个环节。<br />为一个对象分配内存的过程是在连接步骤的准备环节，它是先于“初始化”步骤的，而构造函数的执行是在“初始化”步骤中的。</p>
<p>附注2:<br />Java6 API文档中对于内存一致性(Memory Consistency Properties)的描述：</p>
<p>内存一致性属性</p>
<p>Java Language Specification 第 17 章定义了内存操作（如共享变量的读写）的 happen-before 关系。只有写入操作 happen-before 读取操作时，才保证一个线程写入的结果对另一个线程的读取是可视的。synchronized 和 volatile 构造 happen-before 关系，Thread.start() 和 Thread.join() 方法形成 happen-before 关系。尤其是：</p>
<p>1) 线程中的每个操作 happen-before 稍后按程序顺序传入的该线程中的每个操作。<br />2) 一个解除锁监视器的（synchronized 阻塞或方法退出）happen-before 相同监视器的每个后续锁（synchronized 阻塞或方法进入）。并且因为 happen-before 关系是可传递的，所以解除锁定之前的线程的所有操作 happen-before 锁定该监视器的任何线程后续的所有操作。<br />3) 写入 volatile 字段 happen-before 每个后续读取相同字段。volatile 字段的读取和写入与进入和退出监视器具有相似的内存一致性效果，但不 需要互斥锁。<br />4) 在线程上调用 start happen-before 已启动的线程中的任何线程。<br />5) 线程中的所有操作 happen-before 从该线程上的 join 成功返回的任何其他线程。<br />java.util.concurrent 中所有类的方法及其子包扩展了这些对更高级别同步的保证。尤其是：<br />6) 线程中将一个对象放入任何并发 collection 之前的操作 happen-before 从另一线程中的 collection 访问或移除该元素的后续操作。<br />7) 线程中向 Executor 提交 Runnable 之前的操作 happen-before 其执行开始。同样适用于向 ExecutorService 提交 Callables。<br />8) 异步计算（由 Future 表示）所采取的操作 happen-before 通过另一线程中 Future.get() 获取结果后续的操作。<br />9) “释放”同步储存方法（如 Lock.unlock、Semaphore.release 和 CountDownLatch.countDown）之前的操作 happen-before 另一线程中相同同步储存对象成功“获取”方法（如 Lock.lock、Semaphore.acquire、Condition.await 和 CountDownLatch.await）的后续操作。<br />10) 对于通过 Exchanger 成功交换对象的每个线程对，每个线程中 exchange() 之前的操作 happen-before 另一线程中对应 exchange() 后续的操作。<br />11) 调用 CyclicBarrier.await 之前的操作 happen-before 屏障操作所执行的操作，屏障操作所执行的操作 happen-before 从另一线程中对应 await 成功返回的后续操作。</p>
<p>后续补充：<br />附注一种所引用的文章（Double-Checked Locking is Broken）是一篇比较著名的文章，但也比较早；他所使用的JIT还是Symantec（赛门铁克）JIT，这是一个很古老的JIT，早已经退出了Java舞台，不过我了解了一下历史，在SUN的HotSpot JIT出现之前，Symantec JIT曾是市场上编译最快的JIT。</p>
<p>Symantec的JIT反汇编后证明的逻辑，并不一定证明其他其他JIT也是这样的，我不清楚用什么工具能将java执行过程用汇编语言表达出来。没有去证明其他的编译器。</p>
<p>所以我所描述的new一个对象的场景不一定是完全正确的（不同的编译器未必都和Symantec的实现方式一致），但是始终存在reording 优化，即使编译器没有做，也有可能在cpu级去做，所以new一个对象的过程对多线程访问始终存在不确定性。</p>
<p>特别说明：尊重作者的劳动成果，转载请注明出处哦~~~http://blog.yemou.net/article/query/info/tytfjhfascvhzxcyt201</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 14:58:44</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/javaconcurrenthashmap/" title="javaConcurrentHashMap">javaConcurrentHashMap</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>深入剖析ConcurrentHashMap 一的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlKa8Db.html" rel="bookmark">深度剖析ConcurrentHashMap源码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 你可能会在一些技术类的书籍上看到下面这样一段关于HahsMap和Hashtable的表述: HashMap是非线程安全的,Hashtable是线程安全的. 不知道大家有什么反应,我当时只是记住了,知道面试的时候能回答上来就行了-至于为什么是线程安全的,内部怎么实现的,却不怎么了解. 今天我们将深入剖析一个比Hashtable性能更优的线程安全的Map类,它就是ConcurrentHashMap,本文基于Java 7的源码做剖析. ConcurrentHashMap的目的 多线程环境下,使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vbQr5oM.html" rel="bookmark">深入剖析ConcurrentHashMap&lpar;2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				经过之前的铺垫,现在可以进入正题了. 我们关注的操作有:get,put,remove 这3个操作. 对于哈希表,Java中采用链表的方式来解决hash冲突的. 一个HashMap的数据结构看起来类似下图: 实现了同步的HashTable也是这样的结构,它的同步使用锁来保证的,并且所有同步操作使用的是同一个锁对象.这样若有n个线程同时在get时,这n个线程要串行的等待来获取锁. ConcurrentHashMap中对这个数据结构,针对并发稍微做了一点调整. 它把区间按照并发级别(concurren			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd6k16b.html" rel="bookmark">深入剖析ConcurrentHashMap&lpar;1&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文是09年时写的,在公司的邮件列表发过,同事一粟 和清英 创建的并发编程网 对这方面概念和实战有更好的文章,贴出来仅供参考.pdf格式在:http://www.slideshare.net/hongjiang/concurrent-hashmap 可以获取 ConcurrentHashMap是Java5中新增加的一个线程安全的Map集合,可以用来替代HashTable.对于ConcurrentHashMap是如何提高其效率的,可能大多人只是知道它使用了多个锁代替HashTable中的单个锁,也			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdR3eNb.html" rel="bookmark">深入剖析ConcurrentHashMap二</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				接上一篇: http://blog.yemou.net/article/query/info/tytfjhfascvhzxcyt201 我们关注的操作有:get,put,remove 这3个操作. 对于哈希表,Java中采用链表的方式来解决hash冲突的.一个HashMap的数据结构看起来类似下图: 实现了同步的HashTable也是这样的结构,它的同步使用锁来保证的,并且所有同步操作使用的是同一个锁对象.这样若有n个线程同时在get时,这n个线程要串行的等待来获取锁. ConcurrentHa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9bBvk4b.html" rel="bookmark">Java集合源码剖析：HashMap源码剖析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				HashMap简介 HashMap是基于哈希表实现的,每一个元素是一个key-value对,其内部通过单链表解决冲突问题,容量不足(超过了阀值)时,同样会自动增长. HashMap是非线程安全的,只是用于单线程环境下,多线程环境下可以采用concurrent并发包下的concurrentHashMap. HashMap 实现了Serializable接口,因此它支持序列化,实现了Cloneable接口,能被克隆. HashMap源码剖析 HashMap的源码如下(加入了比较详细的注释): pac			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPjmZp.html" rel="bookmark">Spring源码剖析&mdash;&mdash;Bean的配置与启动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				IOC介绍   相信大多数人在学习Spring时 IOC 和 Bean 算得上是最常听到的两个名词,IOC在学习Spring当中出现频率如此之高必然有其原因.如果我们做一个比喻的话,把Bean说成Spring中主角的话,那么IOC便是这个主角进行演出的舞台,没有IOC作为Bean的承载,那么Bean便不会在编程中大放异彩.作为Spring核心组件的重要一员,了解其内部实现对我们编程和窥探Spring内幕是相当有帮助的,下面一步步从源码的角度来剖析IOC究竟是怎样实现的. 接口设计   首先我们先			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx0BqRM.html" rel="bookmark">tomcat集群实现源码级别剖析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着互联网快速发展,各种各样供外部访问的系统越来越多且访问量越来越大,以前Web容器可以包揽接收-逻辑处理-响应整个请求生命周期的工作,现在为了构建让更多用户访问更强大的系统,人们通过不断地业务解耦.架构解耦将web容器的逻辑处理抽离交由其他中间件处理,例如缓存中间件.消息队列中间件.数据存储中间件等等.Web容器负责的工作可能越来越少,但是它确实必不可少的部分,它负责接收用户请求并分别调用各个服务最后响应.可以说目前最受欢迎的web容器是用Java写的tomcat小猫,由于生产上的tomcat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvGQAp.html" rel="bookmark">WCF技术剖析之十一：异步操作在WCF中的应用（下篇）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说完了客户端的异步服务调用(参阅WCF技术剖析之十一:异步操作在WCF中的应用(上篇)),我们在来谈谈服务端如何通过异步的方式为服务提供实现.在定义服务契约的时候,相信大家已经注意到了OperationContractAttribute特性具有一个bool类型的AsynPattern.该属性可以将一个服务操作定义成异步实现模式,接下来的内容主要是着眼于介绍异步操作的定义和实现原理. 一.异步操作的定义和实现原理 实现WCF异步服务操作模式在编程上具有一些限制:异步服务操作是通过两个配对的方法实现			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM6Z6LM.html" rel="bookmark">Mongoose源码剖析：外篇之web服务器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 在深入Mongoose源码剖析之前,我们应该清楚web服务器是什么?它提供什么服务?怎样提供服务?使用什么协议?客户端如何唯一标识web服务器的资源?下面我们抛开Mongoose,来介绍一个web服务的这些通性. web服务器:通常是指一个计算机程序(web服务器是什么?),在World Wide Web上提供诸如web页面的服务(提供什么服务?),使用HyperText Transfer Protocol(HTTP)(使用什么协议?).当然web服务器也可以指运行这个程序的计算机或虚拟机			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeKJjM.html" rel="bookmark" class="title">网站优化的主旋律就是网站权重</a>
					<div>
						从最初涉足seo到现在,有六个年头了,虽然现在早已不是单纯的做seo的工作了,不过这些年在seo方面的一些积累和经验相信对现在正在从事SEO工作的朋友会有所帮助,请认真看完本文,并积极去思考,你将在s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M06rmz.html" rel="bookmark" class="title">IE8的一个BUG：Hack 兼容方案</a>
					<div>
						字体真是个麻烦的东西,然后又是个重要的东西.为以更方的解决字体问题,就像上次推荐的&lt;再谈 Web 默认字体&gt;,为了Pixel Perfect,我们不断纠结.像支付宝在CSS Reset中是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlY3ap.html" rel="bookmark" class="title">Photoshop实例教程&colon;文字拼凑成面的美女头像</a>
					<div>
						这篇photoshop教程主要应用了自定义笔刷 色彩范围 通道和蒙版制作一款由文字拼凑成面的美女头像,效果还算不错,先看效果图. 1.首先打开一幅美女图片,你可以用其它图片,尺寸最好大些. 2.Ctr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdonmM.html" rel="bookmark" class="title">虚实网站设计五年seo经验总结</a>
					<div>
						转眼间虚实网站设计已经5年了,在这5年中网站经过了几次改版,但是到现在还是有很多不如意的地方,有很多缺陷,很多是历史遗留问题,没办法弥补,感觉要是再有一次一定比现在有的好多了,下面我还是对我这5年的经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AdoWp.html" rel="bookmark" class="title">并发数据结构&colon;谈谈volatile变量</a>
					<div>
						由来 在CLR 2.0 Memory Model中,我们知道现代CPU架构从CPU到Memory Controller每一级都有速度,容量 不同的高速缓存.之所以这样设计,主要是因为性能.为了进一步提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGeyop.html" rel="bookmark" class="title">Photoshop给美女照片加上柔和的古典褐色调</a>
					<div>
						图片颜色比较单调,整体以暗绿色为主.处理的时候可以把暗绿色部分转为褐色,稍亮的绿色转为黄绿色.这样可以增强图片的层次感和柔和度. 原图 &lt;点小图查看大图&gt; 最终效果 1.打开素材图片,创建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZd0KkM.html" rel="bookmark" class="title">JavaScript日期相减得到第二个日期</a>
					<div>
						  JavaScript日期相减计算,然后得到第二个日期.在平时遇到时间加减的机率也是比较大,以下JS函数可完成指定天数减去某天数,计算出另外一个日期,在很多地方都可以用到.需要的可看下函数代码,里面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRwVxp.html" rel="bookmark" class="title">模糊照片如何处理更清晰呢？</a>
					<div>
						  &quot;模糊照片如何处理更清晰呢?&quot;以上这种方法是我经常使用的方法,关键是简单粗暴,5步就可以完成 分类: PS图片处理					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXNnnp.html" rel="bookmark" class="title">Win8&period;1系统主题设置技巧</a>
					<div>
						  同Win7/XP系统一样,在Win8.1系统中我们也可以通过设置主题来个性化我们的操作系统,我们可以创建自定义的Win8.1系统主题,并与好友分享.下面小编就为大家介绍一下Win8.1系统主题设置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaVQmM.html" rel="bookmark" class="title">win7锁屏密码输错锁定电脑防止他人一直循环输入密码</a>
					<div>
						  1.首先,点击开始菜单再附件里面找到运行,点击打开它. 2.在&quot;运行&quot;对话框中输入&quot;gPEdit.msc&quot;,点击确定打开&quot;组策略编辑器&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWX9kAp.html" rel="bookmark" class="title">&lbrack;Maven实战&rsqb;（2）Eclipse插件m2eclipse</a>
					<div>
						1. 简介 Eclipse是一款非常优秀的IDE.除了基本的语法标亮,代码补齐,XML编辑等基本功能之外,最新版的Eclipse还能很好的支持重构,并且集成了JUnit,CVS等各种流行工具.可惜Ec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1NyNb.html" rel="bookmark" class="title">bootstrap datepicker 与bootstrapValidator同时使用时选择日期后无法正常触发校验的解决思路&lowbar;javascript技巧</a>
					<div>
						一.前言 使用bootstrap-datepicker和bootstrapValidator也有一段时间了,在工作中发现两者同时使用时会出现的一种问题,当选择完日期后,并不会正确校验该字段.为了更加直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwx56vb.html" rel="bookmark" class="title">什么样的人才是我们创业时真正福星？</a>
					<div>
						            导语:这个处在高速信息化的时代,吸引了和创造了很多财富神话:因此,特别是本身就处在这个领域的人们来说,几乎每个人都拥有创业的冲动,但,嗯就是这个但,促使了很多&quot;英雄& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAYPGM.html" rel="bookmark" class="title">sqlserver 存储过程-关于SQL存储过程使用游标循环的问题</a>
					<div>
						问题描述 关于SQL存储过程使用游标循环的问题 现有三张表a.b.c,循环表a,把a 表的某个字段作为b表的查询条件,如果b表查出的数据满足某个条件,就往c表里插一条数据,怎么写个存储过程?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7qDWz.html" rel="bookmark" class="title">html5多出来的字自动隐藏并显示&period;&period;&period;</a>
					<div>
						   					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrQaNM.html" rel="bookmark" class="title">adobe Acrobat Profession 7 繁体版本</a>
					<div>
						问题描述 adobe Acrobat Profession 7 繁体版本 adobe Acrobat Profession 7 繁体版本 解决方案 这个问题查找一下,Google 或者 Baidu 一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlB5rp.html" rel="bookmark" class="title">泸州NGN属南气矿工程----华为s2600磁盘阵列问题解决</a>
					<div>
						 磁盘阵列-S2600  OceanStor: admin&gt; chgctrlip -c a -a 172.29.163.39 -s 255.255.255.240 -g 172.29.163.1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RVJqb.html" rel="bookmark" class="title">【以太坊】本地搭建Ethereum私有网络</a>
					<div>
						环境 xiaoyu@xiaoyu-VirtualBox:~$ uname -a Linux xiaoyu-VirtualBox 4.10.0-19-generic #21-Ubuntu SMP Thu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Rw2Bb.html" rel="bookmark" class="title">无眠之夜01  --数据库迁移</a>
					<div>
						上周五10点钟接到老马通知说赣州旅店管理系统数据库要做迁移,把现有的Dell 2850 Windows Service 2003 迁移到Linux云上面.而且下午15点就要开始做迁移工作,17点必须要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5V5QM.html" rel="bookmark" class="title">icon-地址栏ico图标不显示，在FF下可以显示Chorme也可以显示，就是在IE下不能显示 IE版本9</a>
					<div>
						问题描述 地址栏ico图标不显示,在FF下可以显示Chorme也可以显示,就是在IE下不能显示 IE版本9 RT,地址栏ico图标不显示,在FF下可以显示Chorme也可以显示,就是在IE下不能显示  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJwL9p.html" rel="bookmark" class="title">芯片行业上演疯狂并购 交易额两年内超2400亿美元</a>
					<div>
						北京时间11月15日消息,据外媒报道,在经过一系列并购交易后,芯片行业的交易商们也该休息一下了,而且市场中可供他们选择的优质交易也不多了. 金融数据提供商Dealogic的数据显示,过去两年,半导体公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjw5OM.html" rel="bookmark" class="title">编程与行程</a>
					<div>
						    学习编程不是一朝一日能够成功的,学了一年半了,突然觉得编程与行程有异曲同工之妙.请看下图:      也许你有些看不懂上图,下面我解释一下上图.     假如我们在北京,要到上海去,我们从来没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXWG6b.html" rel="bookmark" class="title">史炜：推进三网融合发展力量来自企业</a>
					<div>
						史炜:推进 三网融合发展 力量来自企业 特约撰稿 史炜 工信部很快就会对三网融合发布具体的发展规划和相关的监管措施.这个月关于三网融合.两化融合.融合时代电信增值业务发展对策的研讨会.峰会及专家论坛也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR16VGb.html" rel="bookmark" class="title">mysql 临时表和内存表创建 查询 删除以及注意事项</a>
					<div>
						mysql教程 临时表和内存表创建 查询 删除以及注意事项 临时表和内存表的engine 不同,临时表默认的是myisam,而内存表是memory ,临时表只对当前会话可见,连接断开时,自动删除! 你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7L97M.html" rel="bookmark" class="title">JMeter压力测试问题</a>
					<div>
						问题描述 刚接触到Jmeter,还不太熟悉,现在需要进行Http测试,方法是post,需要向服务器传递一个数据包,请问如何发?要测试的应用是:用户要上传自己的数据,并没有对应的页面,只是客服端将自己的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenaWjb.html" rel="bookmark" class="title">中国第一笔互联网交易开始</a>
					<div>
						返还网fanhuan.com创始人陈方毅 返还网 [电商样本]时间是条长河.从1998年3月完成中国第一笔互联网交易开始,电商企业风起云涌,生生灭灭,既有从1999年成立至今的当当网,也有举巨资高调进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdJBKM.html" rel="bookmark" class="title">Akamai完成对云安全提供商Prolexic的收购</a>
					<div>
						北京时间3721.html&quot;&gt;2014年2月19日, Akamai今天宣布已完成对Prolexic公司的收购.Prolexic是一家总部位于佛罗里达州好莱坞的云安全解决方案提供商,其产 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRdoW8z.html" rel="bookmark" class="title">政策很给力：家用光伏电站随建随拿补贴 完全不受限</a>
					<div>
						环保绿色正成为时尚,越来越多的国人转向低碳生活.王菲.姜昆.滕矢初.黄征等大明星在自家屋顶上安装了汉能薄膜太阳能户用发电系统,身体力行地建设&quot;美丽中国&quot;. 姜昆表示:&quot;我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOWNlRz.html" rel="bookmark" class="title">仁和药业拒绝&OpenCurlyDoubleQuote;召回&rdquo;老版优卡丹难脱质疑</a>
					<div>
						追踪 优卡丹被指有毒性仁和药业(000650) (000650,SZ)&quot;优卡丹&quot;小儿氨酚烷胺颗粒对儿童肝肾有毒性的消息闹得沸沸扬扬.1月27日,江西省药监局发布公告称,&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjEEA8z.html" rel="bookmark" class="title">联发科拿下高通专利协议有望代工高端品牌</a>
					<div>
						很少有人真正去关心那些名不见经传的无名小卒,直到这些草根转眼变成大树后,人们才不得不重新审视并提出疑问--在日新月异的商业市场中,究竟谁才是真正的王者 或许,从今往后,业界再也不宜称呼联发科为山寨电子 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
